# FILE: procs.tcl
#
# Misc. Tcl support code for the mmsolve application.
#

proc SlurpImageFile { filename varname } {
    # Fills $varname with a PPM representation of the data in filename
    upvar $varname var

    # First open file directly
    set chanid [open $filename r]
    set var [read $chanid 2]
    if {![string match P3 $var]} {
        # Input file is not PPM P3 (ASCII) type.  Send through filter.
        close $chanid
        set var {}
        if {[catch {
                Oc_Application CommandLine any2ppm -noinfo -o - $filename
            } cmdLine]} {
            return -code error "Can't find any2ppm program to convert\
                    image file $filename to PPM P3 format."
        }
        set cmdLine [linsert $cmdLine 0 |]
        set chanid [open $cmdLine r]
    }
    fconfigure $chanid -translation binary \
            -buffering full -buffersize 250000
    append var [read $chanid]
    close $chanid
}

