/* FILE: exchange6ngbr.h            -*-Mode: c++-*-
 *
 * 6 neighbor exchange energy on rectangular mesh,
 * derived from Oxs_Energy class.
 *
 */

#ifndef _OXS_EXCHANGE6NGBR
#define _OXS_EXCHANGE6NGBR

#include "key.h"
#include "energy.h"
#include "mesh.h"
#include "meshvalue.h"
#include "simstate.h"
#include "threevector.h"
#include "rectangularmesh.h"

/* End includes */

class Oxs_Exchange6Ngbr:public Oxs_Energy {
private:
  REAL8m A;
  Oxs_Key<Oxs_RectangularMesh> meshkey;
public:
  virtual const char* ClassName() const; // ClassName() is
  /// automatically generated by the OXS_EXT_REGISTER macro.
  virtual BOOL Init();
  Oxs_Exchange6Ngbr(const char* name,     // Child instance id
		    Oxs_Director* newdtr, // App director
		    Tcl_Interp* safe_interp, // Safe interpreter
		    const char* argstr);  // MIF input block parameters
  virtual ~Oxs_Exchange6Ngbr();

  virtual void GetEnergyAndField(const Oxs_SimState& state,
                                 Oxs_MeshValue<REAL8m>& energy,
                                 Oxs_MeshValue<ThreeVector>& field
                                 ) const;
};


#endif // _OXS_EXCHANGE6NGBR
